import hashlib

class PCR:

    def __init__(self, halg):
        self.halg = halg
        self.reset()

    def reset(self):
        self.value = b'\x00' * hashlib.new(self.halg).digest_size
        
    def extend(self, e):
        m = hashlib.new(self.halg)
        m.update(self.value)
        m.update(e)
        self.value = m.digest()

    def read(self):
        return self.value

pcr = PCR('sha256')
pcr.extend(b'checksum of 1st stage boot loader')        # add measurement
pcr.extend(b'checksum of 2nd stage boot loader')        # add measurement
pcr.extend(b'checksum of kernel')                       # add measurement
pcr.extend(b'checksum of initrd')                       # add measurement
print(pcr.read().hex())
